#include "stdafx.h"

void c_print(char *x) {

	unsigned i = 0;

	if ((bgiven.dansi == 0) && (bgiven.dcolor == 0))
		while (x[i] != '\0') {
			SetConsoleTextAttribute(tscreen.screen,tscreen.Cattrib);
			putchar(x[i++]);
		}
	else printf(x);

	return;
}

int getcur(void) {

	CONSOLE_SCREEN_BUFFER_INFO wBuff;

	if (_isatty(_fileno(stdout)) == 0) {
		tscreen.rows = 25;
		tscreen.columns = 80;
		if (bgiven.dansi == 0) bgiven.dcolor = 1;
		bgiven.dbrowse = 1;
		bgiven.dclear = 0;
		tscreen.Oattrib = 0x0007;
		tscreen.Cattrib = 0x0007;
		bgiven.file = 1;
		return(0);
	}
	
	tscreen.screen = GetStdHandle(STD_OUTPUT_HANDLE);
	GetConsoleScreenBufferInfo(tscreen.screen,&wBuff);

	tscreen.window = wBuff.srWindow;
	tscreen.rows = (tscreen.window.Bottom - tscreen.window.Top) + 1;
	tscreen.columns = (tscreen.window.Right - tscreen.window.Left) + 1;

	bgiven.file = 0;

	if (tscreen.columns < 13) return(-1);
	if (tscreen.rows < 5) return(-2);

	tscreen.Oattrib = wBuff.wAttributes;
	tscreen.Cattrib = tscreen.Oattrib;

	return(0);
}

void scurs(BOOL i) {

	CONSOLE_CURSOR_INFO cur;

	if (bgiven.file == 1) return;

	GetConsoleCursorInfo(tscreen.screen,&cur);

	if (cur.bVisible == i) return;
	cur.bVisible = i;
	SetConsoleCursorInfo(tscreen.screen,&cur);

	return;
}

void sclear(void) {

	COORD Wndow;
	short i;
	DWORD chars = 0;

	if (bgiven.file == 1) return;

	Wndow.X = tscreen.window.Left;

	for (i = tscreen.window.Top; i <= tscreen.window.Bottom; i++) {
		Wndow.Y = i;
		FillConsoleOutputCharacter(tscreen.screen,' ',(DWORD)tscreen.columns,Wndow,&chars);
	}
	Wndow.Y = tscreen.window.Top;

	lastrow(0);

	return;
}

void tcolor(WORD cc) {

	char dansi[13] = "\x1b[32;40";
	WORD crow = tscreen.Oattrib;
	int i = 7;
	int flag = 0;

	if (bgiven.dcolor) return;

	if (bgiven.dansi) {
		printf("\x1b[0m");
		if (cc == crow) return;
		if (cc & 0x80) {
			dansi[i++] = ';';
			dansi[i++] = '5';
			bgiven.cflags |= 1;
		}
		if (cc & 0x08) {
			dansi[i++] = ';';
			dansi[i++] = '1';
		}
		dansi[i++] = 'm';
		dansi[i] = '\0';

		crow = (crow >> 4) & 0x07;
		cc &= 0x07;

		if (cc == 1) cc = 4;
			else if (cc == 4) cc = 1;
		if (cc == 3) cc = 6;
			else if (cc == 6) cc = 3;
		if (crow == 1) crow = 4;
			else if (crow == 4) crow = 1;
		if (crow == 3) crow = 6;
			else if (crow == 6) crow = 3;

		dansi[3] = (char)cc + '0';
		dansi[6] = (char)crow + '0';

		printf(dansi);
	} else {
		tscreen.Cattrib = (tscreen.Cattrib & 0xFFF0) | (cc & 0x000F);
		SetConsoleTextAttribute(tscreen.screen,tscreen.Cattrib);
	}
		
	return;

}

void scrlfor(void) {

	COORD NewLoc;
	CHAR_INFO fChar;
	SMALL_RECT nWin;
	
	if (bgiven.file == 1) return;

	NewLoc.X = tscreen.window.Left;
	NewLoc.Y = tscreen.window.Top;

	fChar.Attributes = tscreen.Cattrib;
	fChar.Char.UnicodeChar = ' ';
	fChar.Char.AsciiChar = ' ';
	
	--tscreen.window.Bottom;
	nWin = tscreen.window;
	++nWin.Top;
	ScrollConsoleScreenBuffer(tscreen.screen,&nWin,&tscreen.window,NewLoc,&fChar);
	++tscreen.window.Bottom;
	
	lastrow(0);

	return;
}

void scrlback(void) {

	COORD NewLoc;
	CHAR_INFO fChar;
	
	if (bgiven.file == 1) return;

	NewLoc.X = tscreen.window.Left;
	NewLoc.Y = (tscreen.window.Top + 1);

	fChar.Attributes = tscreen.Cattrib;
	fChar.Char.UnicodeChar = ' ';
	fChar.Char.AsciiChar = ' ';

	--tscreen.window.Bottom;
	ScrollConsoleScreenBuffer(tscreen.screen,&tscreen.window,&tscreen.window,NewLoc,&fChar);
	++tscreen.window.Bottom;
	
	lastrow(1);

	return;
}

void lastrow(char x) {

	COORD NewLoc;
	DWORD chars = 0;
	CONSOLE_SCREEN_BUFFER_INFO cur;

	if (bgiven.file == 1) return;

	NewLoc.X = tscreen.window.Left;

	if (x == 0) NewLoc.Y = tscreen.window.Bottom - 1;
	if (x == 1) NewLoc.Y = tscreen.window.Top;
	if (x == 2) {
		NewLoc.Y = tscreen.window.Bottom;
		FillConsoleOutputCharacter(tscreen.screen,' ',(DWORD)tscreen.columns,NewLoc,&chars);
		FillConsoleOutputAttribute(tscreen.screen,tscreen.Oattrib,(DWORD)tscreen.columns,NewLoc,&chars);
	}
	if (x == 3) {
		GetConsoleScreenBufferInfo(tscreen.screen,&cur);
		NewLoc.Y = cur.dwCursorPosition.Y;
		FillConsoleOutputCharacter(tscreen.screen,' ',(DWORD)tscreen.columns,NewLoc,&chars);
		FillConsoleOutputAttribute(tscreen.screen,tscreen.Oattrib,(DWORD)tscreen.columns,NewLoc,&chars);
		if (NewLoc.Y > 0) --NewLoc.Y;
		NewLoc.X = tscreen.window.Right;
	}
	if (x == 4) NewLoc.Y = tscreen.window.Bottom;

	SetConsoleCursorPosition(tscreen.screen,NewLoc);

	return;
}